<?php
if (!defined('XOOPS_ROOT_PATH')) exit();

/**
 * 񡦥ȡʥȰ
 */
class BBSB_ViewTournamentlistAction extends BBSB_AbstractEditAction
{
	var $mDelMsg			= null;		// 쥳ɺå
	var $mTmList			= array();	// ȡʥȥǡ
	var $mGoList			= array();	// ȥǡ
	var $mAdminMode			= null;		// Ը¤Ĥɤ

	function __construct($mydirname){
		parent::__construct($mydirname);
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/AbstractDatabase.class.php";
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/DbTournament.class.php";
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/DbGameOrder.class.php";
	}

	/**
	 * ¹ν
	 */
	function prepare(&$controller, &$xoopsUser, $moduleConfig)
	{
		parent::prepare(&$controller, &$xoopsUser, $moduleConfig);
		// ¤Τ桼ʳɽԲ
		if( is_object($controller->mRoot->mContext->mXoopsUser) ){
			$this->mAdminMode = $controller->mRoot->mContext->mXoopsUser->isAdmin($controller->mRoot->mContext->mModule->mXoopsModule->get('mid'));
		}
		if( !$this->mAdminMode ){
			$controller->executeForward(XOOPS_URL . '/');
		}

		// Хб
		if (class_exists('Wizin_User')) {	//Wizmobile
			$mobile_user = & Wizin_User::getSingleton();
			$this->mMobile = $mobile_user->bIsMobile;
		}
	}

	function getDefaultView(&$controller, &$xoopsUser)
	{
		// ⡼ɻ
		if( xoops_getrequest('del') ){
			$this->mDelMsg = _MD_BBSB_INFO_DELOK;	// MSG
		}

		// 񡦥ȡʥ
		$dbTm = new BBSB_DbTournament($this->mMyDirName);
		// Ƚ
		$sortarray= array( '1'=>'TournamentID', '2'=>'TournamentName' );
		if( xoops_getrequest('sort') ){
			$sort = xoops_getrequest('sort');
			if( $sort >= 0 ){
				$dir = 'ASC';
			} else {
				$dir = 'DESC';
				$sort = -$sort;
			}
			$dbTm->setOrderBy( $sortarray[$sort], $dir);
		} else {
			// ǥեɽϡ֥ȡʥ̾
			$dbTm->setOrderBy( 'TournamentName', 'ASC');
		}
		// ȯ
		$this->mTmList = $dbTm->getListbyCond('bb_tournament');
		if( $this->mTmList === false ){
			return BBSB_FRAME_VIEW_ERROR;
		}

		// 
		$dbGo = new BBSB_DbGameOrder($this->mMyDirName);
		$dbGo->setOrderBy( 'GameOrderName', 'ASC');	// ǥեɽϡֲ̾
		// ȯ
		$this->mGoList = $dbGo->getListbyCond('bb_gameorder');
		if( $this->mGoList === false ){
			return BBSB_FRAME_VIEW_ERROR;
		}

		return BBSB_FRAME_VIEW_INDEX;
	}

	/**
	 * ¹
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function execute( &$controller, &$xoopsUser )
	{
		// ܥ󲡲delɬ
		if( !xoops_getrequest('del') ){
			$controller->executeForward(XOOPS_URL . '/');
		}
		$id = xoops_getrequest('del');

		// delϺ⡼()
		$adminmode = null;
		if( is_object($controller->mRoot->mContext->mXoopsUser) ){
			$adminmode = $controller->mRoot->mContext->mXoopsUser->isAdmin($controller->mRoot->mContext->mModule->mXoopsModule->get('mid'));
		}
		if( !$adminmode ){
			return BBSB_FRAME_VIEW_ERROR;
		}

		if( xoops_getrequest('tm') ){
			// ȡʥȥơ֥
			$dbTm = new BBSB_DbTournament($this->mMyDirName);
			$dbTm->setData( 'TournamentID',	$id );
			$ret = $dbTm->delete('bb_tournament');
		} else if( xoops_getrequest('go')){
			// ơ֥
			$dbGo = new BBSB_DbGameOrder($this->mMyDirName);
			$dbGo->setData( 'GameOrderID',	$id );
			$ret = $dbGo->delete('bb_gameorder');
		}

		return BBSB_FRAME_VIEW_SUCCESS;
	}

	function executeViewIndex(&$controller, &$xoopsUser, &$render)
	{
		if( $this->mMobile ){
			$render->setTemplateName("bbsb_viewtournamentlistM.html");
		} else {
			$render->setTemplateName("bbsb_viewtournamentlist.html");
			$render->setAttribute('xoops_module_header', _BBSB_OP_CSSFILE . _BBSB_OP_BBSB_COMMON_JS);
		}

		$render->setAttribute('delmsg',			$this->mDelMsg);		// å
		$render->setAttribute('tmlist',			$this->mTmList);		// ȡʥȾ
		$render->setAttribute('golist',			$this->mGoList);		// 
		$render->setAttribute('modname',	$controller->mRoot->mContext->mModule->mXoopsModule->get('name'));
		$render->setAttribute('submenu',	constant($this->mConstPref . '_MENU_TOURNAMENT') );
	}
	/**
	 * ΤȤȡʥȰ̤(̺ɽ)
	 */
	function executeViewSuccess(&$controller, &$xoopsUser, &$render)
	{
		$del	= xoops_getrequest('del');
		if( $del ){
			$del = "&del=" . $del;
		}
		$controller->executeForward("./index.php?action=ViewTournamentlist" . $del );
	}

	/**
	 * 顼ν
	 */
	function executeViewError(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeRedirect("index.php", 1, _MD_BBSB_ERROR_DATABASEUPDATE);
	}

}
?>